declare function join(array: string[], fn: string[] | ((index: number) => string)): string;
declare function delay(time?: number): Promise<unknown>;
declare function getFuncArgs(fn: Function): string;
declare function isStringTemplateArray(data: any): boolean;
declare function isObject(data: any): any;
declare function splitTwoPart(str: string, sep: string): string[];
declare const isSafari: boolean;
declare function mergeSet(s1?: Set<any>, s2?: Set<any>): any;
declare function assignLast(a1: any[], v: any): void;
declare function isSimpleValue(v: any): boolean;

declare const type: unique symbol;
declare const util: unique symbol;
declare const child: unique symbol;
declare const empty: unique symbol;
declare const trig: unique symbol;
declare const pureproxy: unique symbol;

var version = "0.0.24";

/*
 * @Author: tackchen
 * @Date: 2022-10-11 16:41:40
 * @Description: Coding something
 */
interface IJson<T = any> {
    [prop: string | symbol]: T;
}

declare enum AlinsType {
    ElementBuilder = 1,
    Element = 2,
    TextNode = 3,
    Proxy = 4,
    Ref = 5,
    BindResult = 6,
    If = 7,
    Switch = 8
}

/*
 * @Author: tackchen
 * @Date: 2022-10-23 19:26:19
 * @Description: Coding something
 */


type ISimpleValue = string|number|boolean;

type IOnChange<T = string> = (nv: T, ov: T, path: string, prop: string, remove?: boolean) => void;

// Reactive
interface IProxyUtils {
  path: string[];
  lns: IProxyListenerMap;
  commonLns?: Set<IOnChange>;
  triggerChange: (property: string, nv: any, old?: any, remove?: boolean, isNew?: boolean) => void;
  forceWrite: (v: any) => void;
  subscribe: (ln: IProxyListener<any>, deep?: boolean) => void;
  isArray: boolean;
  shallow: boolean;
  forceUpdate: ()=>void;
  // clearCache: ()=>void;
  proxy: IProxyData<any>;
  scopeItems?: any[];
  replaceLns?: boolean;
  extraLns?: Set<IProxyListenerMap>;
}

interface IProxyBase<T extends AlinsType.Proxy|AlinsType.Ref> {
  // @ts-ignore
  [util]: IProxyUtils;
  // @ts-ignore
  [type]: T;
}

interface IRefData<T=any> extends IProxyBase<AlinsType.Ref> {
  v: T;
}


type IProxyData<
    T,
    K = T extends object ? (T & IProxyBase<AlinsType.Proxy>) : IRefData<T>
> = K;

type IProxyListener<T = any> = IOnChange<T>;
type IProxyListenerMap = IJson<Set<IOnChange>>;

export { AlinsType, IJson, IOnChange, IProxyData, IProxyListener, IProxyListenerMap, IProxyUtils, IRefData, ISimpleValue, assignLast, child, delay, empty, getFuncArgs, isObject, isSafari, isSimpleValue, isStringTemplateArray, join, mergeSet, pureproxy, splitTwoPart, trig, type, util, version };
